require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_HYPERVREG_H_)) {
    eval 'sub _HYPERVREG_H_ () {1;}' unless defined(&_HYPERVREG_H_);
    eval 'sub VMBUS_CONNID_MESSAGE () {1;}' unless defined(&VMBUS_CONNID_MESSAGE);
    eval 'sub VMBUS_CONNID_EVENT () {2;}' unless defined(&VMBUS_CONNID_EVENT);
    eval 'sub VMBUS_SINT_MESSAGE () {2;}' unless defined(&VMBUS_SINT_MESSAGE);
    eval 'sub VMBUS_GPADL_START () {0xffff;}' unless defined(&VMBUS_GPADL_START);
    eval 'sub MSR_HV_GUEST_OS_ID () {0x40000000;}' unless defined(&MSR_HV_GUEST_OS_ID);
    eval 'sub MSR_HV_GUESTID_BUILD_MASK () {0xffff;}' unless defined(&MSR_HV_GUESTID_BUILD_MASK);
    eval 'sub MSR_HV_GUESTID_VERSION_MASK () {281474976645120;}' unless defined(&MSR_HV_GUESTID_VERSION_MASK);
    eval 'sub MSR_HV_GUESTID_VERSION_SHIFT () {16;}' unless defined(&MSR_HV_GUESTID_VERSION_SHIFT);
    eval 'sub MSR_HV_GUESTID_OSID_MASK () {7.17761190612173e+16;}' unless defined(&MSR_HV_GUESTID_OSID_MASK);
    eval 'sub MSR_HV_GUESTID_OSID_SHIFT () {48;}' unless defined(&MSR_HV_GUESTID_OSID_SHIFT);
    eval 'sub MSR_HV_GUESTID_OSTYPE_MASK () {9.15131444281685e+18;}' unless defined(&MSR_HV_GUESTID_OSTYPE_MASK);
    eval 'sub MSR_HV_GUESTID_OSTYPE_SHIFT () {56;}' unless defined(&MSR_HV_GUESTID_OSTYPE_SHIFT);
    eval 'sub MSR_HV_GUESTID_OPENSRC () {9.22337203685478e+18;}' unless defined(&MSR_HV_GUESTID_OPENSRC);
    eval 'sub MSR_HV_GUESTID_OSTYPE_LINUX () {((0x1 <<  &MSR_HV_GUESTID_OSTYPE_SHIFT) |  &MSR_HV_GUESTID_OPENSRC);}' unless defined(&MSR_HV_GUESTID_OSTYPE_LINUX);
    eval 'sub MSR_HV_GUESTID_OSTYPE_FREEBSD () {((0x2 <<  &MSR_HV_GUESTID_OSTYPE_SHIFT) |  &MSR_HV_GUESTID_OPENSRC);}' unless defined(&MSR_HV_GUESTID_OSTYPE_FREEBSD);
    eval 'sub MSR_HV_HYPERCALL () {0x40000001;}' unless defined(&MSR_HV_HYPERCALL);
    eval 'sub MSR_HV_HYPERCALL_ENABLE () {0x1;}' unless defined(&MSR_HV_HYPERCALL_ENABLE);
    eval 'sub MSR_HV_HYPERCALL_RSVD_MASK () {0xffe;}' unless defined(&MSR_HV_HYPERCALL_RSVD_MASK);
    eval 'sub MSR_HV_HYPERCALL_PGSHIFT () {12;}' unless defined(&MSR_HV_HYPERCALL_PGSHIFT);
    eval 'sub MSR_HV_VP_INDEX () {0x40000002;}' unless defined(&MSR_HV_VP_INDEX);
    eval 'sub MSR_HV_TIME_REF_COUNT () {0x40000020;}' unless defined(&MSR_HV_TIME_REF_COUNT);
    eval 'sub MSR_HV_SCONTROL () {0x40000080;}' unless defined(&MSR_HV_SCONTROL);
    eval 'sub MSR_HV_SCTRL_ENABLE () {0x1;}' unless defined(&MSR_HV_SCTRL_ENABLE);
    eval 'sub MSR_HV_SCTRL_RSVD_MASK () {1.84467440737096e+19;}' unless defined(&MSR_HV_SCTRL_RSVD_MASK);
    eval 'sub MSR_HV_SIEFP () {0x40000082;}' unless defined(&MSR_HV_SIEFP);
    eval 'sub MSR_HV_SIEFP_ENABLE () {0x1;}' unless defined(&MSR_HV_SIEFP_ENABLE);
    eval 'sub MSR_HV_SIEFP_RSVD_MASK () {0xffe;}' unless defined(&MSR_HV_SIEFP_RSVD_MASK);
    eval 'sub MSR_HV_SIEFP_PGSHIFT () {12;}' unless defined(&MSR_HV_SIEFP_PGSHIFT);
    eval 'sub MSR_HV_SIMP () {0x40000083;}' unless defined(&MSR_HV_SIMP);
    eval 'sub MSR_HV_SIMP_ENABLE () {0x1;}' unless defined(&MSR_HV_SIMP_ENABLE);
    eval 'sub MSR_HV_SIMP_RSVD_MASK () {0xffe;}' unless defined(&MSR_HV_SIMP_RSVD_MASK);
    eval 'sub MSR_HV_SIMP_PGSHIFT () {12;}' unless defined(&MSR_HV_SIMP_PGSHIFT);
    eval 'sub MSR_HV_EOM () {0x40000084;}' unless defined(&MSR_HV_EOM);
    eval 'sub MSR_HV_SINT0 () {0x40000090;}' unless defined(&MSR_HV_SINT0);
    eval 'sub MSR_HV_SINT_VECTOR_MASK () {0xff;}' unless defined(&MSR_HV_SINT_VECTOR_MASK);
    eval 'sub MSR_HV_SINT_RSVD1_MASK () {0xff00;}' unless defined(&MSR_HV_SINT_RSVD1_MASK);
    eval 'sub MSR_HV_SINT_MASKED () {0x10000;}' unless defined(&MSR_HV_SINT_MASKED);
    eval 'sub MSR_HV_SINT_AUTOEOI () {0x20000;}' unless defined(&MSR_HV_SINT_AUTOEOI);
    eval 'sub MSR_HV_SINT_RSVD2_MASK () {1.84467440737093e+19;}' unless defined(&MSR_HV_SINT_RSVD2_MASK);
    eval 'sub MSR_HV_SINT_RSVD_MASK () {( &MSR_HV_SINT_RSVD1_MASK |  &MSR_HV_SINT_RSVD2_MASK);}' unless defined(&MSR_HV_SINT_RSVD_MASK);
    eval 'sub MSR_HV_STIMER0_CONFIG () {0x400000b0;}' unless defined(&MSR_HV_STIMER0_CONFIG);
    eval 'sub MSR_HV_STIMER_CFG_ENABLE () {0x1;}' unless defined(&MSR_HV_STIMER_CFG_ENABLE);
    eval 'sub MSR_HV_STIMER_CFG_PERIODIC () {0x2;}' unless defined(&MSR_HV_STIMER_CFG_PERIODIC);
    eval 'sub MSR_HV_STIMER_CFG_LAZY () {0x4;}' unless defined(&MSR_HV_STIMER_CFG_LAZY);
    eval 'sub MSR_HV_STIMER_CFG_AUTOEN () {0x8;}' unless defined(&MSR_HV_STIMER_CFG_AUTOEN);
    eval 'sub MSR_HV_STIMER_CFG_SINT_MASK () {0xf0000;}' unless defined(&MSR_HV_STIMER_CFG_SINT_MASK);
    eval 'sub MSR_HV_STIMER_CFG_SINT_SHIFT () {16;}' unless defined(&MSR_HV_STIMER_CFG_SINT_SHIFT);
    eval 'sub MSR_HV_STIMER0_COUNT () {0x400000b1;}' unless defined(&MSR_HV_STIMER0_COUNT);
    eval 'sub CPUID_LEAF_HV_MAXLEAF () {0x40000000;}' unless defined(&CPUID_LEAF_HV_MAXLEAF);
    eval 'sub CPUID_LEAF_HV_INTERFACE () {0x40000001;}' unless defined(&CPUID_LEAF_HV_INTERFACE);
    eval 'sub CPUID_HV_IFACE_HYPERV () {0x31237648;}' unless defined(&CPUID_HV_IFACE_HYPERV);
    eval 'sub CPUID_LEAF_HV_IDENTITY () {0x40000002;}' unless defined(&CPUID_LEAF_HV_IDENTITY);
    eval 'sub CPUID_LEAF_HV_FEATURES () {0x40000003;}' unless defined(&CPUID_LEAF_HV_FEATURES);
    eval 'sub CPUID_HV_MSR_TIME_REFCNT () {0x2;}' unless defined(&CPUID_HV_MSR_TIME_REFCNT);
    eval 'sub CPUID_HV_MSR_SYNIC () {0x4;}' unless defined(&CPUID_HV_MSR_SYNIC);
    eval 'sub CPUID_HV_MSR_SYNTIMER () {0x8;}' unless defined(&CPUID_HV_MSR_SYNTIMER);
    eval 'sub CPUID_HV_MSR_APIC () {0x10;}' unless defined(&CPUID_HV_MSR_APIC);
    eval 'sub CPUID_HV_MSR_HYPERCALL () {0x20;}' unless defined(&CPUID_HV_MSR_HYPERCALL);
    eval 'sub CPUID_HV_MSR_VP_INDEX () {0x40;}' unless defined(&CPUID_HV_MSR_VP_INDEX);
    eval 'sub CPUID_HV_MSR_GUEST_IDLE () {0x400;}' unless defined(&CPUID_HV_MSR_GUEST_IDLE);
    eval 'sub CPUPM_HV_CSTATE_MASK () {0xf;}' unless defined(&CPUPM_HV_CSTATE_MASK);
    eval 'sub CPUPM_HV_C3_HPET () {0x10;}' unless defined(&CPUPM_HV_C3_HPET);
    eval 'sub CPUPM_HV_CSTATE {
        my($f) = @_;
	    eval q((($f) &  &CPUPM_HV_CSTATE_MASK));
    }' unless defined(&CPUPM_HV_CSTATE);
    eval 'sub CPUID3_HV_MWAIT () {0x1;}' unless defined(&CPUID3_HV_MWAIT);
    eval 'sub CPUID3_HV_XMM_HYPERCALL () {0x10;}' unless defined(&CPUID3_HV_XMM_HYPERCALL);
    eval 'sub CPUID3_HV_GUEST_IDLE () {0x20;}' unless defined(&CPUID3_HV_GUEST_IDLE);
    eval 'sub CPUID3_HV_NUMA () {0x80;}' unless defined(&CPUID3_HV_NUMA);
    eval 'sub CPUID3_HV_TIME_FREQ () {0x100;}' unless defined(&CPUID3_HV_TIME_FREQ);
    eval 'sub CPUID3_HV_MSR_CRASH () {0x400;}' unless defined(&CPUID3_HV_MSR_CRASH);
    eval 'sub CPUID_LEAF_HV_RECOMMENDS () {0x40000004;}' unless defined(&CPUID_LEAF_HV_RECOMMENDS);
    eval 'sub CPUID_LEAF_HV_LIMITS () {0x40000005;}' unless defined(&CPUID_LEAF_HV_LIMITS);
    eval 'sub CPUID_LEAF_HV_HWFEATURES () {0x40000006;}' unless defined(&CPUID_LEAF_HV_HWFEATURES);
    eval 'sub VMBUS_MSGTYPE_NONE () {0;}' unless defined(&VMBUS_MSGTYPE_NONE);
    eval 'sub VMBUS_MSGTYPE_CHANNEL () {1;}' unless defined(&VMBUS_MSGTYPE_CHANNEL);
    eval 'sub VMBUS_MSGTYPE_TIMER_EXPIRED () {0x80000010;}' unless defined(&VMBUS_MSGTYPE_TIMER_EXPIRED);
    eval 'sub HYPERCALL_STATUS_SUCCESS () {0x;}' unless defined(&HYPERCALL_STATUS_SUCCESS);
    eval 'sub HYPERCALL_POST_MESSAGE () {0x5c;}' unless defined(&HYPERCALL_POST_MESSAGE);
    eval 'sub HYPERCALL_SIGNAL_EVENT () {0x5d;}' unless defined(&HYPERCALL_SIGNAL_EVENT);
    eval 'sub HYPERCALL_PARAM_ALIGN () {8;}' unless defined(&HYPERCALL_PARAM_ALIGN);
    if(0) {
	eval 'sub HYPERCALL_PARAM_SIZE_ALIGN () {8;}' unless defined(&HYPERCALL_PARAM_SIZE_ALIGN);
    }
    eval 'sub HYPERCALL_POSTMSGIN_DSIZE_MAX () {240;}' unless defined(&HYPERCALL_POSTMSGIN_DSIZE_MAX);
    eval 'sub HYPERCALL_POSTMSGIN_SIZE () {256;}' unless defined(&HYPERCALL_POSTMSGIN_SIZE);
    eval 'sub VMBUS_VERSION_WS2008 () {((0<< 16) | (13));}' unless defined(&VMBUS_VERSION_WS2008);
    eval 'sub VMBUS_VERSION_WIN7 () {((1<< 16) | (1));}' unless defined(&VMBUS_VERSION_WIN7);
    eval 'sub VMBUS_VERSION_WIN8 () {((2<< 16) | (4));}' unless defined(&VMBUS_VERSION_WIN8);
    eval 'sub VMBUS_VERSION_WIN8_1 () {((3<< 16) | (0));}' unless defined(&VMBUS_VERSION_WIN8_1);
    eval 'sub VMBUS_VERSION_MAJOR {
        my($ver) = @_;
	    eval q(((( &uint32_t)($ver)) >> 16));
    }' unless defined(&VMBUS_VERSION_MAJOR);
    eval 'sub VMBUS_VERSION_MINOR {
        my($ver) = @_;
	    eval q(((( &uint32_t)($ver)) & 0xffff));
    }' unless defined(&VMBUS_VERSION_MINOR);
    eval 'sub VMBUS_CHANPKT_SIZE_SHIFT () {3;}' unless defined(&VMBUS_CHANPKT_SIZE_SHIFT);
    eval 'sub VMBUS_CHANPKT_GETLEN {
        my($pktlen) = @_;
	    eval q(((($pktlen)) <<  &VMBUS_CHANPKT_SIZE_SHIFT));
    }' unless defined(&VMBUS_CHANPKT_GETLEN);
    eval 'sub VMBUS_CHANPKT_TYPE_INBAND () {0x6;}' unless defined(&VMBUS_CHANPKT_TYPE_INBAND);
    eval 'sub VMBUS_CHANPKT_TYPE_RXBUF () {0x7;}' unless defined(&VMBUS_CHANPKT_TYPE_RXBUF);
    eval 'sub VMBUS_CHANPKT_TYPE_GPA () {0x9;}' unless defined(&VMBUS_CHANPKT_TYPE_GPA);
    eval 'sub VMBUS_CHANPKT_TYPE_COMP () {0xb;}' unless defined(&VMBUS_CHANPKT_TYPE_COMP);
    eval 'sub VMBUS_CHANPKT_FLAG_RC () {0x1;}' unless defined(&VMBUS_CHANPKT_FLAG_RC);
    eval 'sub VMBUS_CHANPKT_CONST_DATA {
        my($pkt) = @_;
	    eval q((( &const  &void *)(( &const  &uint8_t *)($pkt) +  &VMBUS_CHANPKT_GETLEN(($pkt)-> &cph_hlen))));
    }' unless defined(&VMBUS_CHANPKT_CONST_DATA);
    eval 'sub VMBUS_MSG_DSIZE_MAX () {240;}' unless defined(&VMBUS_MSG_DSIZE_MAX);
    eval 'sub VMBUS_MSG_SIZE () {256;}' unless defined(&VMBUS_MSG_SIZE);
    eval 'sub VMBUS_MSGFLAG_PENDING () {0x1;}' unless defined(&VMBUS_MSGFLAG_PENDING);
    eval 'sub VMBUS_EVTFLAGS_SIZE () {256;}' unless defined(&VMBUS_EVTFLAGS_SIZE);
    eval 'sub VMBUS_EVTFLAGS_MAX () {(( &VMBUS_EVTFLAGS_SIZE /  &LONG_BIT) * 8);}' unless defined(&VMBUS_EVTFLAGS_MAX);
    eval 'sub VMBUS_EVTFLAG_LEN () { &LONG_BIT;}' unless defined(&VMBUS_EVTFLAG_LEN);
    eval 'sub VMBUS_EVTFLAG_MASK () {( &LONG_BIT - 1);}' unless defined(&VMBUS_EVTFLAG_MASK);
    eval 'sub VMBUS_MONTRIGS_MAX () {4;}' unless defined(&VMBUS_MONTRIGS_MAX);
    eval 'sub VMBUS_MONTRIG_LEN () {32;}' unless defined(&VMBUS_MONTRIG_LEN);
    eval 'sub VMBUS_CHAN_MAX_COMPAT () {256;}' unless defined(&VMBUS_CHAN_MAX_COMPAT);
    eval 'sub VMBUS_CHAN_MAX () {( &VMBUS_EVTFLAG_LEN *  &VMBUS_EVTFLAGS_MAX);}' unless defined(&VMBUS_CHAN_MAX);
    eval 'sub VMBUS_CHANPKT_SIZE_ALIGN () {(1<<  &VMBUS_CHANPKT_SIZE_SHIFT);}' unless defined(&VMBUS_CHANPKT_SIZE_ALIGN);
    eval 'sub VMBUS_CHANPKT_SETLEN {
        my($pktlen, $len) = @_;
	    eval q( &do { ($pktlen) = ($len) >>  &VMBUS_CHANPKT_SIZE_SHIFT; }  &while (0));
    }' unless defined(&VMBUS_CHANPKT_SETLEN);
    eval 'sub VMBUS_CHANMSG_CHOFFER () {1;}' unless defined(&VMBUS_CHANMSG_CHOFFER);
    eval 'sub VMBUS_CHANMSG_CHRESCIND () {2;}' unless defined(&VMBUS_CHANMSG_CHRESCIND);
    eval 'sub VMBUS_CHANMSG_CHREQUEST () {3;}' unless defined(&VMBUS_CHANMSG_CHREQUEST);
    eval 'sub VMBUS_CHANMSG_CHOFFER_DONE () {4;}' unless defined(&VMBUS_CHANMSG_CHOFFER_DONE);
    eval 'sub VMBUS_CHANMSG_CHOPEN () {5;}' unless defined(&VMBUS_CHANMSG_CHOPEN);
    eval 'sub VMBUS_CHANMSG_CHOPEN_RESP () {6;}' unless defined(&VMBUS_CHANMSG_CHOPEN_RESP);
    eval 'sub VMBUS_CHANMSG_CHCLOSE () {7;}' unless defined(&VMBUS_CHANMSG_CHCLOSE);
    eval 'sub VMBUS_CHANMSG_GPADL_CONN () {8;}' unless defined(&VMBUS_CHANMSG_GPADL_CONN);
    eval 'sub VMBUS_CHANMSG_GPADL_SUBCONN () {9;}' unless defined(&VMBUS_CHANMSG_GPADL_SUBCONN);
    eval 'sub VMBUS_CHANMSG_GPADL_CONNRESP () {10;}' unless defined(&VMBUS_CHANMSG_GPADL_CONNRESP);
    eval 'sub VMBUS_CHANMSG_GPADL_DISCONN () {11;}' unless defined(&VMBUS_CHANMSG_GPADL_DISCONN);
    eval 'sub VMBUS_CHANMSG_GPADL_DISCONNRESP () {12;}' unless defined(&VMBUS_CHANMSG_GPADL_DISCONNRESP);
    eval 'sub VMBUS_CHANMSG_CHFREE () {13;}' unless defined(&VMBUS_CHANMSG_CHFREE);
    eval 'sub VMBUS_CHANMSG_CONNECT () {14;}' unless defined(&VMBUS_CHANMSG_CONNECT);
    eval 'sub VMBUS_CHANMSG_CONNECT_RESP () {15;}' unless defined(&VMBUS_CHANMSG_CONNECT_RESP);
    eval 'sub VMBUS_CHANMSG_DISCONNECT () {16;}' unless defined(&VMBUS_CHANMSG_DISCONNECT);
    eval 'sub VMBUS_CHANMSG_COUNT () {17;}' unless defined(&VMBUS_CHANMSG_COUNT);
    eval 'sub VMBUS_CHANMSG_MAX () {22;}' unless defined(&VMBUS_CHANMSG_MAX);
    eval 'sub VMBUS_CHANMSG_CHOPEN_UDATA_SIZE () {120;}' unless defined(&VMBUS_CHANMSG_CHOPEN_UDATA_SIZE);
    eval 'sub VMBUS_CHANMSG_GPADL_CONN_PGMAX () {26;}' unless defined(&VMBUS_CHANMSG_GPADL_CONN_PGMAX);
    eval 'sub VMBUS_CHANMSG_GPADL_SUBCONN_PGMAX () {28;}' unless defined(&VMBUS_CHANMSG_GPADL_SUBCONN_PGMAX);
    eval 'sub VMBUS_CHOFFER_FLAG1_HASMNF () {0x1;}' unless defined(&VMBUS_CHOFFER_FLAG1_HASMNF);
    eval 'sub HV_ICMSGTYPE_NEGOTIATE () {0;}' unless defined(&HV_ICMSGTYPE_NEGOTIATE);
    eval 'sub HV_ICMSGTYPE_HEARTBEAT () {1;}' unless defined(&HV_ICMSGTYPE_HEARTBEAT);
    eval 'sub HV_ICMSGTYPE_KVPEXCHANGE () {2;}' unless defined(&HV_ICMSGTYPE_KVPEXCHANGE);
    eval 'sub HV_ICMSGTYPE_SHUTDOWN () {3;}' unless defined(&HV_ICMSGTYPE_SHUTDOWN);
    eval 'sub HV_ICMSGTYPE_TIMESYNC () {4;}' unless defined(&HV_ICMSGTYPE_TIMESYNC);
    eval 'sub HV_ICMSGTYPE_VSS () {5;}' unless defined(&HV_ICMSGTYPE_VSS);
    eval 'sub HV_ICMSGHDRFLAG_TRANSACTION () {1;}' unless defined(&HV_ICMSGHDRFLAG_TRANSACTION);
    eval 'sub HV_ICMSGHDRFLAG_REQUEST () {2;}' unless defined(&HV_ICMSGHDRFLAG_REQUEST);
    eval 'sub HV_ICMSGHDRFLAG_RESPONSE () {4;}' unless defined(&HV_ICMSGHDRFLAG_RESPONSE);
    eval 'sub HV_ICMSG_STATUS_OK () {0x;}' unless defined(&HV_ICMSG_STATUS_OK);
    eval 'sub HV_ICMSG_STATUS_FAIL () {0x80004005;}' unless defined(&HV_ICMSG_STATUS_FAIL);
    eval 'sub HV_TIMESYNC_PROBE () {0;}' unless defined(&HV_TIMESYNC_PROBE);
    eval 'sub HV_TIMESYNC_SYNC () {1;}' unless defined(&HV_TIMESYNC_SYNC);
    eval 'sub HV_TIMESYNC_SAMPLE () {2;}' unless defined(&HV_TIMESYNC_SAMPLE);
    eval 'sub HV_NPFNHDR () {(( &VMBUS_MSG_DSIZE_MAX - $sizeof{\'struct vmbus_chanmsg_gpadl_conn\'}) / $sizeof{ &uint64_t});}' unless defined(&HV_NPFNHDR);
    eval 'sub HV_NPFNBODY () {(( &VMBUS_MSG_DSIZE_MAX - $sizeof{\'struct vmbus_chanmsg_gpadl_subconn\'}) / $sizeof{ &uint64_t});}' unless defined(&HV_NPFNBODY);
}
1;
