require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_HYPERVVAR_H_)) {
    eval 'sub _HYPERVVAR_H_ () {1;}' unless defined(&_HYPERVVAR_H_);
    eval 'sub HYPERV_DEBUG () {1;}' unless defined(&HYPERV_DEBUG);
    if(defined(&HYPERV_DEBUG)) {
	eval 'sub DPRINTF () {( &x...)  &printf( &x);}' unless defined(&DPRINTF);
    } else {
	eval 'sub DPRINTF () {( &x...);}' unless defined(&DPRINTF);
    }
    eval 'sub MSGF_NOSLEEP () {0x1;}' unless defined(&MSGF_NOSLEEP);
    eval 'sub MSGF_NOQUEUE () {0x2;}' unless defined(&MSGF_NOQUEUE);
    eval 'sub MSGF_ORPHANED () {0x4;}' unless defined(&MSGF_ORPHANED);
    eval 'sub HV_CHANSTATE_OFFERED () {1;}' unless defined(&HV_CHANSTATE_OFFERED);
    eval 'sub HV_CHANSTATE_OPENED () {2;}' unless defined(&HV_CHANSTATE_OPENED);
    eval 'sub HV_CHANSTATE_CLOSING () {3;}' unless defined(&HV_CHANSTATE_CLOSING);
    eval 'sub HV_CHANSTATE_CLOSED () {4;}' unless defined(&HV_CHANSTATE_CLOSED);
    eval 'sub CHF_BATCHED () {0x1;}' unless defined(&CHF_BATCHED);
    eval 'sub CHF_MONITOR () {0x2;}' unless defined(&CHF_MONITOR);
    eval 'sub HSF_CONNECTED () {0x1;}' unless defined(&HSF_CONNECTED);
    eval 'sub HSF_OFFERS_DELIVERED () {0x2;}' unless defined(&HSF_OFFERS_DELIVERED);
    eval 'sub clear_bit {
        my($b,$p) = @_;
	    eval q({  &atomic_clearbits_int((( &volatile \'u_int\' *)$p) + ($b >> 5), 1<< ($b & 0x1f)); });
    }' unless defined(&clear_bit);
    eval 'sub set_bit {
        my($b,$p) = @_;
	    eval q({  &atomic_setbits_int((( &volatile \'u_int\' *)$p) + ($b >> 5), 1<< ($b & 0x1f)); });
    }' unless defined(&set_bit);
    eval 'sub test_bit {
        my($b,$p) = @_;
	    eval q({ !!((( &volatile \'u_int\' *)$p)[$b >> 5] & (1<< ($b & 0x1f))); });
    }' unless defined(&test_bit);
}
1;
